#include <iostream>
#include <list>
#include <vector>
#include <queue>
#include <set>
#include <map>
#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <algorithm>
#include <ctime>
#include <climits>
#include <cassert>
#include <string.h>

#include "Solver.h"
#include "SimpSolver.h"
#include "System.h"
using namespace std;
#include "e0g-pqe+.hh"
#include "einline.hh"

/*====================================

  A D D _ C U B E

  =====================================*/
void ExQuant::add_cube(CUBE &C,int sgnl_cube_depth, bool clean,bool glb_sgnl)
{

  int cube_ind = F.size();
  
  F.push_back(C); // add C to the formula
  
  // update Flits0 and Flits1

  for (uint i=0; i < C.size(); i++) {
    int lit = C[i];
    if (lit < 0)
      Flits0[-1*lit-1].push_back(cube_ind);
    else
      Flits1[lit-1].push_back(cube_ind);
  }
  
  CubeInfo el;
  el.type = cube_type_check(C);
  if (el.type == Y_CUBE) {
    num_ycubes++;
    if (!clean) dirt_ycubes++;
  }

  

  Clean.push_back(clean);
 
 
  if (glb_sgnl && (el.type != Y_CUBE)) {
    New_prim_scubes.insert(F.size()-1);
    //    printf("adding new primary target\n");
    if (sgnl_cube_depth <= curr_depth)
      el.signal = 1;
    else  el.signal = 0;
    el.glb_sgnl = 1;
  }
  else     
    if ((sgnl_cube_depth <= curr_depth) && (el.type != Y_CUBE))   {
      el.signal = 1;
      el.glb_sgnl = 0;
      curr_num_sgnl_cubes++;
      if (curr_num_sgnl_cubes > max_num_sgnl_cubes)
        max_num_sgnl_cubes = curr_num_sgnl_cubes;
      New_sgnl_cubes[sgnl_cube_depth].push_back(cube_ind);
    }
    else {
      el.signal = 0;
      el.glb_sgnl = 0;
    }
 
  

  el.depth = sgnl_cube_depth;
  
  Cause_lit.push_back(0);
 
  el.state = ACTIVE;
  Cube_info.push_back(el);
  
  CUBE E;
  Act_dseqs.push_back(E);
  Sat_vars.push_back(E);
    
  if (Cube_info[cube_ind].signal)  {
    num_act_sgnl_cubes++;
    increase_sgnl_cube_scores(cube_ind);
  }

  DNF DE;
  Left_dseqs.push_back(DE);
  Red_cube_depth.push_back(-1);
  Ping.push_back(E);
  Ped.push_back(E);
  hash_table_cubes.add_elem();
  hash_table_cubes1.add_elem();
  form_init_prot_cubes();  

  Last_cnfl_cubes.push_back(cube_ind);
 
   
  if (extra_stat_flag)
    Num_of_dseqs.push_back(0);

  
} /* end of function add_cube */
