#include <iostream>
#include <set>
#include <vector>
#include <map>
#include <queue>

#include <stdlib.h>
#include <strings.h>
#include <stdio.h>
#include <assert.h>

#include "Solver.h"
#include "SimpSolver.h"
#include "System.h"
using namespace std;
#include "e0g-pqe+.hh"
#include "einline.hh"

#define buf_size 50000

/*==============================

  R E A D _ N U M B E R

  ===============================*/
int read_number(FILE *fp,int &literal)
{int a;
  char buf[buf_size];
  int pnt=0;
  buf[pnt] = 0;

  while (true) {
    a = fgetc(fp);
    if (a == EOF) {
      if (pnt == 0) return(0); // no symbols have beed read in
      else {
        buf[pnt] = 0;
        literal = atoi(buf);
        return(3);
      }
    }
    if (a == ' ') {
      buf[pnt]=0;
      literal = atoi(buf);
      goto FINISH;
    }

          
    if (a == '\n') {
      buf[pnt]=0;
      literal = atoi(buf);
      goto FINISH;
    }
    assert ((a== '-')|| (a=='+') ||
            ((a >='0') && (a <= '9')));
    buf[pnt++]=a;
  }
 FINISH:
  if (pnt > 0) /* at least one numberic  symbol was seen */
    return(1);
  return(2);

}/* end of function read_number*/

/*=======================================

  R E A D _ N U M B E R S

  We assume that file "fname" contains 
  a set of integers
  =======================================*/
void read_numbers(const char *fname,CUBE &Nums)
{
 
  FILE *fp = fopen(fname,"r");

  if (fp == NULL)  {
    p();
    cout << "cannot open file " << fname << endl;
    exit(ERROR);
  }

  int num;
  int a;
  while (true) {
    while ((a=fgetc(fp)) == ' ') ; // skip spaces
    ungetc(a,fp); 
    int ret_value = read_number(fp,num);
    if (ret_value  == 0) // EOF was encountered */
      break;
    if (ret_value == 2) /* end of line  */
      continue;
   
    Nums.push_back(num); 
    if (ret_value == 3) // EOF was encountered
      break;  
  }
  fclose(fp);

} /* end of function read_numbers */
