#include <iostream>
#include <list>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <queue>
#include <algorithm>
//
#include <stdio.h>
#include <assert.h>
#include <string.h>

#include "Solver.h"
#include "SimpSolver.h"
using namespace std;

#include "e0g-pqe+.hh"
#include "einline.hh"


//
//   GEN_CNFL_CUBE3
//
void gen_cnfl_cube3(CUBE &C,Msolver *Slvr,MvecLits &Assmps)
{

  for (int i=0; i < Assmps.size(); i++) {
    Mlit L = ~Assmps[i];
    if (Slvr->conflict.has(L)) {     
      int lit = mlit_to_lit(Slvr,L);
      C.push_back(lit);
    }
  }
        

} /* gen_cnfl_cube3 */




/*=======================================

  I N I T _ S A T _ S O L V E R

  ======================================*/
Msolver *init_sat_solver(int nvars)
{
  Msolver *S = new Minisat::Solver();

  for (int i = 0; i < nvars; ++i) 
    S->newVar();

  return(S);

} /* end of function init_sat_solver */

/*=================================

  C O N V _ T O _ M C L A U S E

  ===============================*/
void conv_to_mclause(TrivMclause &A, CUBE &C) {

  for (uint i=0; i < C.size(); i++) 
    if (C[i] > 0) A.push(Minisat::mkLit(C[i]-1,false));
    else A.push(Minisat::mkLit(-C[i]-1,true));
  

} /* end of function conv_to_mclause */

/*=======================================

  A C C E P T _ N E W _ C L A U S E

  ========================================*/
void accept_new_clause(Msolver *Slvr,CUBE &C)
{

 
  TrivMclause A;
  conv_to_mclause(A,C);
  Slvr->addClause(A);


}  /* end of function accept_new_clause */

/*=============================

  A D D _ A S S U M P S 

  ============================*/
void add_assumps(MvecLits &Assmps,CUBE &A)
{

  for (uint i=0; i < A.size(); i++) {
    int lit = A[i];
    if (lit < 0) Assmps.push(Minisat::mkLit(-lit-1,true));
    else Assmps.push(Minisat::mkLit(lit-1,false));
  }
    
} /* end of function add_assumps */


/*===========================================

  A D D _ N E G A T E D _ A S S U M P S

  ==========================================*/
void add_negated_assumps(MvecLits &Assmps,CUBE &C)
{

  for (uint i=0; i < C.size(); i++) {
    int lit = C[i];
    if (lit < 0) Assmps.push(Minisat::mkLit(-lit-1,false));
    else Assmps.push(Minisat::mkLit(lit-1,true));
  }
    
} /* end of function add_negated_assumps*/

/*==========================================

  A C C E P T _ N E W _ C L A U S E S

  =========================================*/
void accept_new_clauses(Msolver *Slvr,CNF &H)
{
  for (uint i=0; i < H.size(); i++)
    accept_new_clause(Slvr,H[i]);

} /* end of function accept_new_clauses */


//
//  CHECK_TIME
//
bool ExQuant::check_time()
{

  if (time_limit < 0) return(true);
                             
  double usrtime,systime;
  get_runtime (usrtime, systime);
  return(usrtime < time_limit);

} /* check_time */
